Update NEWS file for 2.9.7 release
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         doc/users \
112         test/data/htools \
113         test/data/htools/rapi \
114         test/hs/shelltests \
115         test/autotools \
116         lib \
117         lib/build \
118         lib/client \
119         lib/cmdlib \
120         lib/confd \
121         lib/http \
122         lib/hypervisor \
123         lib/impexpd \
124         lib/masterd \
125         lib/rapi \
126         lib/server \
127         lib/storage \
128         lib/tools \
129         lib/utils \
130         lib/watcher \
131         man \
132         qa \
133         qa/patch \
134         test \
135         test/data \
136         test/data/bdev-rbd \
137         test/data/ovfdata \
138         test/data/ovfdata/other \
139         test/py \
140         tools
141
142 ALL_APIDOC_HS_DIRS = \
143         $(APIDOC_HS_DIR) \
144         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
145
146 BUILDTIME_DIR_AUTOCREATE = \
147         scripts \
148         $(APIDOC_DIR) \
149         $(ALL_APIDOC_HS_DIRS) \
150         $(APIDOC_PY_DIR) \
151         $(COVERAGE_DIR) \
152         $(COVERAGE_HS_DIR) \
153         $(COVERAGE_PY_DIR) \
154         .hpc
155
156 BUILDTIME_DIRS = \
157         $(BUILDTIME_DIR_AUTOCREATE) \
158         doc/html \
159         doc/man-html
160
161 DIRCHECK_EXCLUDE = \
162         $(BUILDTIME_DIRS) \
163         ganeti-[0-9]*.[0-9]*.[0-9]* \
164         doc/html/_* \
165         doc/man-html/_* \
166         autom4te.cache
167
168 # some helper vars
169 COVERAGE_DIR = doc/coverage
170 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
171 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
172 APIDOC_DIR = doc/api
173 APIDOC_PY_DIR = $(APIDOC_DIR)/py
174 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
175
176 MAINTAINERCLEANFILES = \
177         $(maninput) \
178         doc/install-quick.rst \
179         doc/news.rst \
180         doc/upgrade.rst \
181         vcs-version
182
183 maintainer-clean-local:
184         rm -rf $(BUILDTIME_DIRS)
185
186 CLEANFILES = \
187         $(addsuffix /*.py[co],$(DIRS)) \
188         $(addsuffix /*.hi,$(HS_DIRS)) \
189         $(addsuffix /*.o,$(HS_DIRS)) \
190         $(PYTHON_BOOTSTRAP) \
191         epydoc.conf \
192         $(REPLACE_VARS_SED) \
193         $(SHELL_ENV_INIT) \
194         daemons/daemon-util \
195         daemons/ganeti-cleaner \
196         devel/squeeze-amd64.tar.gz \
197         devel/squeeze-amd64.conf \
198         $(mandocrst) \
199         doc/manpages-enabled.rst \
200         $(BUILT_EXAMPLES) \
201         doc/examples/bash_completion \
202         doc/examples/bash_completion-debug \
203         $(userspecs) \
204         lib/_generated_rpc.py \
205         $(man_MANS) \
206         $(manhtml) \
207         tools/kvm-ifup \
208         tools/vif-ganeti \
209         tools/net-common \
210         tools/users-setup \
211         tools/vcluster-setup \
212         stamp-directories \
213         stamp-srclinks \
214         $(nodist_pkgpython_PYTHON) \
215         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
216         $(HS_BUILT_TEST_HELPERS) \
217         src/ganeti-confd \
218         src/ganeti-luxid \
219         src/ganeti-mond \
220         .hpc/*.mix src/*.tix test/hs/*.tix \
221         doc/hs-lint.html
222
223 GENERATED_FILES = \
224         $(built_base_sources) \
225         $(BUILT_PYTHON_SOURCES) \
226         $(PYTHON_BOOTSTRAP)
227
228 HS_GENERATED_FILES =
229 if WANT_HTOOLS
230 HS_GENERATED_FILES += $(HS_PROGS)
231 if ENABLE_CONFD
232 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
233 endif
234
235 if ENABLE_MOND
236 HS_GENERATED_FILES += src/ganeti-mond
237 endif
238 endif
239
240 built_base_sources = \
241         stamp-directories \
242         stamp-srclinks
243
244 built_python_base_sources = \
245         lib/_autoconf.py \
246         lib/_vcsversion.py
247
248 BUILT_PYTHON_SOURCES = \
249         $(built_python_base_sources) \
250         lib/_generated_rpc.py
251
252 # Generating the RPC wrappers depends on many things, so make sure
253 # it's built at the end of the built sources
254 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
255
256 # these are all built from the underlying %.in sources
257 BUILT_EXAMPLES = \
258         doc/examples/ganeti-kvm-poweroff.initd \
259         doc/examples/ganeti.cron \
260         doc/examples/ganeti.initd \
261         doc/examples/ganeti.logrotate \
262         doc/examples/ganeti-master-role.ocf \
263         doc/examples/ganeti-node-role.ocf \
264         doc/examples/gnt-config-backup \
265         doc/examples/hooks/ipsec
266
267 nodist_pkgpython_PYTHON = \
268         $(BUILT_PYTHON_SOURCES)
269
270 noinst_PYTHON = \
271         lib/build/__init__.py \
272         lib/build/shell_example_lexer.py \
273         lib/build/sphinx_ext.py
274
275 pkgpython_PYTHON = \
276         lib/__init__.py \
277         lib/asyncnotifier.py \
278         lib/backend.py \
279         lib/bootstrap.py \
280         lib/cli.py \
281         lib/compat.py \
282         lib/config.py \
283         lib/constants.py \
284         lib/daemon.py \
285         lib/errors.py \
286         lib/hooksmaster.py \
287         lib/ht.py \
288         lib/jqueue.py \
289         lib/jstore.py \
290         lib/locking.py \
291         lib/luxi.py \
292         lib/mcpu.py \
293         lib/netutils.py \
294         lib/objects.py \
295         lib/opcodes.py \
296         lib/outils.py \
297         lib/ovf.py \
298         lib/pathutils.py \
299         lib/qlang.py \
300         lib/query.py \
301         lib/rpc.py \
302         lib/rpc_defs.py \
303         lib/runtime.py \
304         lib/serializer.py \
305         lib/ssconf.py \
306         lib/ssh.py \
307         lib/uidpool.py \
308         lib/vcluster.py \
309         lib/network.py \
310         lib/workerpool.py
311
312 client_PYTHON = \
313         lib/client/__init__.py \
314         lib/client/gnt_backup.py \
315         lib/client/gnt_cluster.py \
316         lib/client/gnt_debug.py \
317         lib/client/gnt_group.py \
318         lib/client/gnt_instance.py \
319         lib/client/gnt_job.py \
320         lib/client/gnt_node.py \
321         lib/client/gnt_network.py \
322         lib/client/gnt_os.py \
323         lib/client/gnt_storage.py
324
325 cmdlib_PYTHON = \
326         lib/cmdlib/__init__.py \
327         lib/cmdlib/backup.py \
328         lib/cmdlib/base.py \
329         lib/cmdlib/cluster.py \
330         lib/cmdlib/common.py \
331         lib/cmdlib/group.py \
332         lib/cmdlib/instance.py \
333         lib/cmdlib/instance_migration.py \
334         lib/cmdlib/instance_operation.py \
335         lib/cmdlib/instance_query.py \
336         lib/cmdlib/instance_storage.py \
337         lib/cmdlib/instance_utils.py \
338         lib/cmdlib/misc.py \
339         lib/cmdlib/network.py \
340         lib/cmdlib/node.py \
341         lib/cmdlib/operating_system.py \
342         lib/cmdlib/query.py \
343         lib/cmdlib/tags.py \
344         lib/cmdlib/test.py
345
346 hypervisor_PYTHON = \
347         lib/hypervisor/__init__.py \
348         lib/hypervisor/hv_base.py \
349         lib/hypervisor/hv_chroot.py \
350         lib/hypervisor/hv_fake.py \
351         lib/hypervisor/hv_kvm.py \
352         lib/hypervisor/hv_lxc.py \
353         lib/hypervisor/hv_xen.py
354
355 storage_PYTHON = \
356         lib/storage/__init__.py \
357         lib/storage/bdev.py \
358         lib/storage/base.py \
359         lib/storage/container.py \
360         lib/storage/drbd.py \
361         lib/storage/drbd_info.py \
362         lib/storage/drbd_cmdgen.py \
363         lib/storage/filestorage.py
364
365 rapi_PYTHON = \
366         lib/rapi/__init__.py \
367         lib/rapi/baserlib.py \
368         lib/rapi/client.py \
369         lib/rapi/client_utils.py \
370         lib/rapi/connector.py \
371         lib/rapi/rlib2.py \
372         lib/rapi/testutils.py
373
374 http_PYTHON = \
375         lib/http/__init__.py \
376         lib/http/auth.py \
377         lib/http/client.py \
378         lib/http/server.py
379
380 confd_PYTHON = \
381         lib/confd/__init__.py \
382         lib/confd/client.py
383
384 masterd_PYTHON = \
385         lib/masterd/__init__.py \
386         lib/masterd/iallocator.py \
387         lib/masterd/instance.py
388
389 impexpd_PYTHON = \
390         lib/impexpd/__init__.py
391
392 watcher_PYTHON = \
393         lib/watcher/__init__.py \
394         lib/watcher/nodemaint.py \
395         lib/watcher/state.py
396
397 server_PYTHON = \
398         lib/server/__init__.py \
399         lib/server/masterd.py \
400         lib/server/noded.py \
401         lib/server/rapi.py
402
403 pytools_PYTHON = \
404         lib/tools/__init__.py \
405         lib/tools/burnin.py \
406         lib/tools/ensure_dirs.py \
407         lib/tools/node_cleanup.py \
408         lib/tools/node_daemon_setup.py \
409         lib/tools/prepare_node_join.py
410
411 utils_PYTHON = \
412         lib/utils/__init__.py \
413         lib/utils/algo.py \
414         lib/utils/filelock.py \
415         lib/utils/hash.py \
416         lib/utils/io.py \
417         lib/utils/log.py \
418         lib/utils/lvm.py \
419         lib/utils/mlock.py \
420         lib/utils/nodesetup.py \
421         lib/utils/process.py \
422         lib/utils/retry.py \
423         lib/utils/storage.py \
424         lib/utils/text.py \
425         lib/utils/wrapper.py \
426         lib/utils/x509.py
427
428 docinput = \
429         doc/conf.py \
430         doc/css/style.css \
431         doc/admin.rst \
432         doc/cluster-merge.rst \
433         doc/design-2.0.rst \
434         doc/design-2.1.rst \
435         doc/design-2.2.rst \
436         doc/design-2.3.rst \
437         doc/design-2.4.rst \
438         doc/design-2.5.rst \
439         doc/design-2.6.rst \
440         doc/design-2.7.rst \
441         doc/design-2.8.rst \
442         doc/design-2.9.rst \
443         doc/design-autorepair.rst \
444         doc/design-bulk-create.rst \
445         doc/design-chained-jobs.rst \
446         doc/design-cpu-pinning.rst \
447         doc/design-device-uuid-name.rst \
448         doc/design-draft.rst \
449         doc/design-glusterfs-ganeti-support.rst \
450         doc/design-daemons.rst \
451         doc/design-htools-2.3.rst \
452         doc/design-http-server.rst \
453         doc/design-impexp2.rst \
454         doc/design-internal-shutdown.rst \
455         doc/design-lu-generated-jobs.rst \
456         doc/design-linuxha.rst \
457         doc/design-multi-reloc.rst \
458         doc/design-network.rst \
459         doc/design-node-add.rst \
460         doc/design-oob.rst \
461         doc/design-openvswitch.rst \
462         doc/design-ovf-support.rst \
463         doc/design-opportunistic-locking.rst \
464         doc/design-partitioned.rst \
465         doc/design-query-splitting.rst \
466         doc/design-query2.rst \
467         doc/design-reason-trail.rst \
468         doc/design-resource-model.rst \
469         doc/design-restricted-commands.rst \
470         doc/design-shared-storage.rst \
471         doc/design-monitoring-agent.rst \
472         doc/design-virtual-clusters.rst \
473         doc/design-x509-ca.rst \
474         doc/design-hroller.rst \
475         doc/design-storagetypes.rst \
476         doc/devnotes.rst \
477         doc/glossary.rst \
478         doc/hooks.rst \
479         doc/iallocator.rst \
480         doc/index.rst \
481         doc/install-quick.rst \
482         doc/install.rst \
483         doc/locking.rst \
484         doc/manpages-disabled.rst \
485         doc/monitoring-query-format.rst \
486         doc/move-instance.rst \
487         doc/news.rst \
488         doc/ovfconverter.rst \
489         doc/rapi.rst \
490         doc/security.rst \
491         doc/upgrade.rst \
492         doc/virtual-cluster.rst \
493         doc/walkthrough.rst
494
495 # Generates file names such as "doc/man-gnt-instance.rst"
496 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
497
498 # Haskell programs to be installed in $PREFIX/bin
499 HS_BIN_PROGS=src/htools
500
501 # Haskell programs to be installed in the MYEXECLIB dir
502 if ENABLE_MOND
503 HS_MYEXECLIB_PROGS=src/mon-collector
504 else
505 HS_MYEXECLIB_PROGS=
506 endif
507
508 # Haskell programs to be compiled by "make really-all"
509 HS_COMPILE_PROGS= \
510         src/ganeti-mond \
511         src/hconfd \
512         src/hluxid \
513         src/rpc-test
514
515 # All Haskell non-test programs to be compiled but not automatically installed
516 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
517
518 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
519 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
520
521 HS_ALL_PROGS = \
522         $(HS_PROGS) \
523         test/hs/hpc-htools \
524         test/hs/hpc-mon-collector \
525         test/hs/htest \
526         $(HS_COMPILE_PROGS)
527
528 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
529 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
530
531 HFLAGS = \
532         -O -Wall -Werror -isrc \
533         -fwarn-monomorphism-restriction \
534         -fwarn-tabs \
535         $(GHC_BYVERSION_FLAGS)
536
537 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
538 HEXTRA =
539 # internal extra flags (used for test/hs/htest mainly)
540 HEXTRA_INT =
541 # combination of HEXTRA and HEXTRA_CONFIGURE
542 HEXTRA_COMBINED = $(HEXTRA) $(HEXTRA_CONFIGURE)
543 # exclude options for coverage reports
544 HPCEXCL = --exclude Main \
545         --exclude Ganeti.Constants \
546         --exclude Ganeti.HTools.QC \
547         --exclude Ganeti.THH \
548         --exclude Ganeti.Version \
549         --exclude Test.Ganeti.Attoparsec \
550         --exclude Test.Ganeti.TestCommon \
551         --exclude Test.Ganeti.TestHTools \
552         --exclude Test.Ganeti.TestHelper \
553         --exclude Test.Ganeti.TestImports \
554         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
555
556 HS_LIB_SRCS = \
557         src/Ganeti/BasicTypes.hs \
558         src/Ganeti/Common.hs \
559         src/Ganeti/Compat.hs \
560         src/Ganeti/Confd/Client.hs \
561         src/Ganeti/Confd/ClientFunctions.hs \
562         src/Ganeti/Confd/Server.hs \
563         src/Ganeti/Confd/Types.hs \
564         src/Ganeti/Confd/Utils.hs \
565         src/Ganeti/Config.hs \
566         src/Ganeti/ConfigReader.hs \
567         src/Ganeti/Curl/Multi.hs \
568         src/Ganeti/Daemon.hs \
569         src/Ganeti/DataCollectors/CLI.hs \
570         src/Ganeti/DataCollectors/Diskstats.hs \
571         src/Ganeti/DataCollectors/Drbd.hs \
572         src/Ganeti/DataCollectors/InstStatus.hs \
573         src/Ganeti/DataCollectors/InstStatusTypes.hs \
574         src/Ganeti/DataCollectors/Lv.hs \
575         src/Ganeti/DataCollectors/Program.hs \
576         src/Ganeti/DataCollectors/Types.hs \
577         src/Ganeti/Errors.hs \
578         src/Ganeti/HTools/Backend/IAlloc.hs \
579         src/Ganeti/HTools/Backend/Luxi.hs \
580         src/Ganeti/HTools/Backend/Rapi.hs \
581         src/Ganeti/HTools/Backend/Simu.hs \
582         src/Ganeti/HTools/Backend/Text.hs \
583         src/Ganeti/HTools/CLI.hs \
584         src/Ganeti/HTools/Cluster.hs \
585         src/Ganeti/HTools/Container.hs \
586         src/Ganeti/HTools/ExtLoader.hs \
587         src/Ganeti/HTools/Graph.hs \
588         src/Ganeti/HTools/Group.hs \
589         src/Ganeti/HTools/Instance.hs \
590         src/Ganeti/HTools/Loader.hs \
591         src/Ganeti/HTools/Nic.hs \
592         src/Ganeti/HTools/Node.hs \
593         src/Ganeti/HTools/PeerMap.hs \
594         src/Ganeti/HTools/Program/Hail.hs \
595         src/Ganeti/HTools/Program/Harep.hs \
596         src/Ganeti/HTools/Program/Hbal.hs \
597         src/Ganeti/HTools/Program/Hcheck.hs \
598         src/Ganeti/HTools/Program/Hinfo.hs \
599         src/Ganeti/HTools/Program/Hscan.hs \
600         src/Ganeti/HTools/Program/Hspace.hs \
601         src/Ganeti/HTools/Program/Hroller.hs \
602         src/Ganeti/HTools/Program/Main.hs \
603         src/Ganeti/HTools/Types.hs \
604         src/Ganeti/Hypervisor/Xen.hs \
605         src/Ganeti/Hypervisor/Xen/XmParser.hs \
606         src/Ganeti/Hypervisor/Xen/Types.hs \
607         src/Ganeti/Hash.hs \
608         src/Ganeti/JQueue.hs \
609         src/Ganeti/JSON.hs \
610         src/Ganeti/Jobs.hs \
611         src/Ganeti/Logging.hs \
612         src/Ganeti/Luxi.hs \
613         src/Ganeti/Monitoring/Server.hs \
614         src/Ganeti/Network.hs \
615         src/Ganeti/Objects.hs \
616         src/Ganeti/OpCodes.hs \
617         src/Ganeti/OpParams.hs \
618         src/Ganeti/Path.hs \
619         src/Ganeti/Query/Cluster.hs \
620         src/Ganeti/Query/Common.hs \
621         src/Ganeti/Query/Export.hs \
622         src/Ganeti/Query/Filter.hs \
623         src/Ganeti/Query/Group.hs \
624         src/Ganeti/Query/Job.hs \
625         src/Ganeti/Query/Language.hs \
626         src/Ganeti/Query/Network.hs \
627         src/Ganeti/Query/Node.hs \
628         src/Ganeti/Query/Query.hs \
629         src/Ganeti/Query/Server.hs \
630         src/Ganeti/Query/Types.hs \
631         src/Ganeti/Rpc.hs \
632         src/Ganeti/Runtime.hs \
633         src/Ganeti/Ssconf.hs \
634         src/Ganeti/Storage/Diskstats/Parser.hs \
635         src/Ganeti/Storage/Diskstats/Types.hs \
636         src/Ganeti/Storage/Drbd/Parser.hs \
637         src/Ganeti/Storage/Drbd/Types.hs \
638         src/Ganeti/Storage/Lvm/LVParser.hs \
639         src/Ganeti/Storage/Lvm/Types.hs \
640         src/Ganeti/Storage/Utils.hs \
641         src/Ganeti/THH.hs \
642         src/Ganeti/Types.hs \
643         src/Ganeti/Utils.hs
644
645 HS_TEST_SRCS = \
646         test/hs/Test/Ganeti/Attoparsec.hs \
647         test/hs/Test/Ganeti/BasicTypes.hs \
648         test/hs/Test/Ganeti/Common.hs \
649         test/hs/Test/Ganeti/Confd/Types.hs \
650         test/hs/Test/Ganeti/Confd/Utils.hs \
651         test/hs/Test/Ganeti/Daemon.hs \
652         test/hs/Test/Ganeti/Errors.hs \
653         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
654         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
655         test/hs/Test/Ganeti/HTools/CLI.hs \
656         test/hs/Test/Ganeti/HTools/Cluster.hs \
657         test/hs/Test/Ganeti/HTools/Container.hs \
658         test/hs/Test/Ganeti/HTools/Graph.hs \
659         test/hs/Test/Ganeti/HTools/Instance.hs \
660         test/hs/Test/Ganeti/HTools/Loader.hs \
661         test/hs/Test/Ganeti/HTools/Node.hs \
662         test/hs/Test/Ganeti/HTools/PeerMap.hs \
663         test/hs/Test/Ganeti/HTools/Types.hs \
664         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
665         test/hs/Test/Ganeti/JSON.hs \
666         test/hs/Test/Ganeti/Jobs.hs \
667         test/hs/Test/Ganeti/JQueue.hs \
668         test/hs/Test/Ganeti/Luxi.hs \
669         test/hs/Test/Ganeti/Network.hs \
670         test/hs/Test/Ganeti/Objects.hs \
671         test/hs/Test/Ganeti/OpCodes.hs \
672         test/hs/Test/Ganeti/Query/Filter.hs \
673         test/hs/Test/Ganeti/Query/Language.hs \
674         test/hs/Test/Ganeti/Query/Network.hs \
675         test/hs/Test/Ganeti/Query/Query.hs \
676         test/hs/Test/Ganeti/Rpc.hs \
677         test/hs/Test/Ganeti/Runtime.hs \
678         test/hs/Test/Ganeti/Ssconf.hs \
679         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
680         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
681         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
682         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
683         test/hs/Test/Ganeti/THH.hs \
684         test/hs/Test/Ganeti/TestCommon.hs \
685         test/hs/Test/Ganeti/TestHTools.hs \
686         test/hs/Test/Ganeti/TestHelper.hs \
687         test/hs/Test/Ganeti/Types.hs \
688         test/hs/Test/Ganeti/Utils.hs
689
690 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
691
692 HS_BUILT_SRCS = \
693         test/hs/Test/Ganeti/TestImports.hs \
694         src/Ganeti/Constants.hs \
695         src/Ganeti/Curl/Internal.hs \
696         src/Ganeti/Version.hs
697 HS_BUILT_SRCS_IN = \
698         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
699         src/Ganeti/Curl/Internal.hsc
700
701 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
702
703 $(RUN_IN_TEMPDIR): | stamp-directories
704
705 doc/html/index.html: ENABLE_MANPAGES =
706 doc/man-html/index.html: ENABLE_MANPAGES = 1
707 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
708
709 # Note: we use here an order-only prerequisite, as the contents of
710 # _autoconf.py are not actually influencing the html build output: it
711 # has to exist in order for the sphinx module to be loaded
712 # successfully, but we certainly don't want the docs to be rebuilt if
713 # it changes
714 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
715         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
716         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
717         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
718         | $(BUILT_PYTHON_SOURCES)
719         @test -n "$(SPHINX)" || \
720             { echo 'sphinx-build' not found during configure; exit 1; }
721 if !MANPAGES_IN_DOC
722         if test -n '$(ENABLE_MANPAGES)'; then \
723           echo 'Man pages in documentation were disabled at configure time' >&2; \
724           exit 1; \
725         fi
726 endif
727 ## Sphinx provides little control over what content should be included. Some
728 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
729 ## build two different versions of the documentation--once without man pages and
730 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
731 ## us with this, but requires running in a temporary directory. It moves the
732 ## correct files into place depending on environment variables.
733         dir=$(dir $@) && \
734         @mkdir_p@ $$dir && \
735         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
736         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
737             -d . \
738             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
739             -D release="$(PACKAGE_VERSION)" \
740             -D graphviz_dot="$(DOT)" \
741             -D enable_manpages="$(ENABLE_MANPAGES)" \
742             doc $(CURDIR)/$$dir && \
743         rm -f $$dir/.buildinfo $$dir/objects.inv
744         touch $@
745
746 doc/html: doc/html/index.html
747
748 doc/man-html: doc/man-html/index.html
749
750 doc/install-quick.rst: INSTALL
751 doc/news.rst: NEWS
752 doc/upgrade.rst: UPGRADE
753
754 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
755         set -e; \
756         { echo '.. This file is automatically updated at build time from $<.'; \
757           echo '.. Do not edit.'; \
758           echo; \
759           cat $<; \
760         } > $@
761
762 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
763         { echo '.. This file is automatically generated, do not edit!'; \
764           echo ''; \
765           echo 'Man pages'; \
766           echo '========='; \
767           echo; \
768           echo '.. toctree::'; \
769           echo '   :maxdepth: 1'; \
770           echo; \
771           for i in $(notdir $(mandocrst)); do \
772             echo "   $$i"; \
773           done | LC_ALL=C sort; \
774         } > $@
775
776 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
777 if MANPAGES_IN_DOC
778         { echo '.. This file is automatically updated at build time from $<.'; \
779           echo '.. Do not edit.'; \
780           echo; \
781           echo "$*"; \
782           echo '=========================================='; \
783           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
784         } > $@
785 else
786         echo 'Man pages in documentation were disabled at configure time' >&2; \
787         exit 1;
788 endif
789
790 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
791         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
792
793 userspecs = \
794         doc/users/users \
795         doc/users/groups \
796         doc/users/groupmemberships
797
798 # Things to build but not to install (add it to EXTRA_DIST if it should be
799 # distributed)
800 noinst_DATA = \
801         $(BUILT_EXAMPLES) \
802         doc/examples/bash_completion \
803         doc/examples/bash_completion-debug \
804         $(userspecs) \
805         $(manhtml)
806
807 if HAS_SPHINX
808 if MANPAGES_IN_DOC
809 noinst_DATA += doc/man-html
810 else
811 noinst_DATA += doc/html
812 endif
813 endif
814
815 gnt_scripts = \
816         scripts/gnt-backup \
817         scripts/gnt-cluster \
818         scripts/gnt-debug \
819         scripts/gnt-group \
820         scripts/gnt-instance \
821         scripts/gnt-job \
822         scripts/gnt-network \
823         scripts/gnt-node \
824         scripts/gnt-os \
825         scripts/gnt-storage
826
827 PYTHON_BOOTSTRAP_SBIN = \
828         daemons/ganeti-masterd \
829         daemons/ganeti-noded \
830         daemons/ganeti-rapi \
831         daemons/ganeti-watcher \
832         $(gnt_scripts)
833
834 PYTHON_BOOTSTRAP = \
835         $(PYTHON_BOOTSTRAP_SBIN) \
836         tools/burnin \
837         tools/ensure-dirs \
838         tools/node-cleanup \
839         tools/node-daemon-setup \
840         tools/prepare-node-join
841
842 qa_scripts = \
843         qa/__init__.py \
844         qa/ganeti-qa.py \
845         qa/qa_cluster.py \
846         qa/qa_config.py \
847         qa/qa_daemon.py \
848         qa/qa_env.py \
849         qa/qa_error.py \
850         qa/qa_group.py \
851         qa/qa_instance.py \
852         qa/qa_instance_utils.py \
853         qa/qa_job.py \
854         qa/qa_monitoring.py \
855         qa/qa_logging.py \
856         qa/qa_node.py \
857         qa/qa_os.py \
858         qa/qa_rapi.py \
859         qa/qa_tags.py \
860         qa/qa_utils.py
861
862 bin_SCRIPTS =
863 if WANT_HTOOLS
864 bin_SCRIPTS += $(HS_BIN_PROGS)
865 install-exec-hook:
866         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
867 # FIXME: this is a hardcoded logic, instead of auto-resolving
868         $(LN_S) -f ../../../bin/htools \
869           $(DESTDIR)$(iallocatorsdir)/hail
870         for role in $(HS_BIN_ROLES); do \
871           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
872         done
873 endif
874
875 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
876         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
877           echo "Error: cannot run unittests without the development" \
878                " libraries (see devnotes.rst)" 1>&2; \
879           exit 1; \
880         fi
881         @rm -f $(notdir $@).tix
882         $(GHC) --make \
883           $(HFLAGS) \
884           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
885           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
886           $(HEXTRA_COMBINED) $(HEXTRA_INT) $@
887         @touch "$@"
888
889 # for the test/hs/htest binary, we need to enable profiling/coverage
890 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
891
892 # we compile the hpc-htools binary with the program coverage
893 test/hs/hpc-htools: HEXTRA_INT=-fhpc
894
895 # we compile the hpc-mon-collector binary with the program coverage
896 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
897
898 # test dependency
899 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
900
901 # rules for building profiling-enabled versions of the haskell
902 # programs: hs-prof does the full two-step build, whereas
903 # hs-prof-quick does only the final rebuild (hs-prof must have been
904 # run before)
905 .PHONY: hs-prof hs-prof-quick
906 hs-prof:
907         @if [ -z "$(TARGET)" ]; then \
908           echo "You need to define TARGET when running this rule" 1>&2; \
909           exit 1; \
910         fi
911         $(MAKE) $(AM_MAKEFLAGS) clean
912         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
913         rm -f $(HS_ALL_PROGS)
914         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
915
916 hs-prof-quick:
917         @if [ -z "$(TARGET)" ]; then \
918           echo "You need to define TARGET when running this rule" 1>&2; \
919           exit 1; \
920         fi
921         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
922
923 dist_sbin_SCRIPTS = \
924         tools/ganeti-listrunner
925
926 nodist_sbin_SCRIPTS = \
927         $(PYTHON_BOOTSTRAP_SBIN) \
928         daemons/ganeti-cleaner
929
930 if ENABLE_CONFD
931 src/ganeti-confd: src/hconfd
932         cp -f $< $@
933
934 src/ganeti-luxid: src/hluxid
935         cp -f $< $@
936
937 nodist_sbin_SCRIPTS += src/ganeti-confd
938 nodist_sbin_SCRIPTS += src/ganeti-luxid
939 endif
940
941 if ENABLE_MOND
942 nodist_sbin_SCRIPTS += src/ganeti-mond
943 endif
944
945 python_scripts = \
946         tools/cfgshell \
947         tools/cfgupgrade \
948         tools/cfgupgrade12 \
949         tools/cluster-merge \
950         tools/confd-client \
951         tools/fmtjson \
952         tools/lvmstrap \
953         tools/move-instance \
954         tools/ovfconverter \
955         tools/sanitize-config
956
957 dist_tools_SCRIPTS = \
958         $(python_scripts) \
959         tools/burnin \
960         tools/kvm-console-wrapper \
961         tools/master-ip-setup \
962         tools/xen-console-wrapper
963
964 nodist_tools_python_scripts = \
965         tools/node-cleanup
966
967 nodist_tools_SCRIPTS = \
968         $(nodist_tools_python_scripts) \
969         tools/users-setup \
970         tools/vcluster-setup
971
972 pkglib_python_scripts = \
973         daemons/import-export \
974         tools/check-cert-expired
975
976 nodist_pkglib_python_scripts = \
977         tools/ensure-dirs \
978         tools/node-daemon-setup \
979         tools/prepare-node-join
980
981 myexeclib_SCRIPTS = \
982         daemons/daemon-util \
983         tools/kvm-ifup \
984         tools/vif-ganeti \
985         tools/net-common \
986         $(pkglib_python_scripts) \
987         $(HS_MYEXECLIB_PROGS)
988
989 nodist_myexeclib_SCRIPTS = \
990         $(nodist_pkglib_python_scripts)
991
992 EXTRA_DIST = \
993         NEWS \
994         UPGRADE \
995         epydoc.conf.in \
996         pylintrc \
997         autotools/build-bash-completion \
998         autotools/build-rpc \
999         autotools/check-header \
1000         autotools/check-imports \
1001         autotools/check-man-dashes \
1002         autotools/check-man-references \
1003         autotools/check-man-warnings \
1004         autotools/check-news \
1005         autotools/check-python-code \
1006         autotools/check-tar \
1007         autotools/check-version \
1008         autotools/convert-constants \
1009         autotools/docpp \
1010         autotools/gen-py-coverage \
1011         autotools/sphinx-wrapper \
1012         autotools/testrunner \
1013         autotools/wrong-hardcoded-paths \
1014         $(RUN_IN_TEMPDIR) \
1015         daemons/daemon-util.in \
1016         daemons/ganeti-cleaner.in \
1017         $(pkglib_python_scripts) \
1018         devel/upload \
1019         devel/webserver \
1020         tools/kvm-ifup.in \
1021         tools/vif-ganeti.in \
1022         tools/net-common.in \
1023         tools/vcluster-setup.in \
1024         $(docinput) \
1025         doc/html \
1026         $(BUILT_EXAMPLES:%=%.in) \
1027         doc/examples/ganeti.default \
1028         doc/examples/ganeti.default-debug \
1029         doc/examples/hooks/ethers \
1030         doc/examples/gnt-debug/README \
1031         doc/examples/gnt-debug/delay0.json \
1032         doc/examples/gnt-debug/delay50.json \
1033         doc/users/groupmemberships.in \
1034         doc/users/groups.in \
1035         doc/users/users.in \
1036         test/py/lockperf.py \
1037         test/py/testutils.py \
1038         test/py/mocks.py \
1039         $(dist_TESTS) \
1040         $(TEST_FILES) \
1041         man/footer.rst \
1042         $(manrst) \
1043         $(maninput) \
1044         qa/qa-sample.json \
1045         $(qa_scripts) \
1046         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1047         $(HS_PROG_SRCS) \
1048         src/lint-hints.hs \
1049         test/hs/cli-tests-defs.sh \
1050         test/hs/offline-test.sh \
1051         .ghci
1052
1053 man_MANS = \
1054         man/ganeti-cleaner.8 \
1055         man/ganeti-confd.8 \
1056         man/ganeti-luxid.8 \
1057         man/ganeti-listrunner.8 \
1058         man/ganeti-masterd.8 \
1059         man/ganeti-mond.8 \
1060         man/ganeti-noded.8 \
1061         man/ganeti-os-interface.7 \
1062         man/ganeti-extstorage-interface.7 \
1063         man/ganeti-rapi.8 \
1064         man/ganeti-watcher.8 \
1065         man/ganeti.7 \
1066         man/gnt-backup.8 \
1067         man/gnt-cluster.8 \
1068         man/gnt-debug.8 \
1069         man/gnt-group.8 \
1070         man/gnt-network.8 \
1071         man/gnt-instance.8 \
1072         man/gnt-job.8 \
1073         man/gnt-node.8 \
1074         man/gnt-os.8 \
1075         man/gnt-storage.8 \
1076         man/hail.1 \
1077         man/harep.1 \
1078         man/hbal.1 \
1079         man/hcheck.1 \
1080         man/hinfo.1 \
1081         man/hscan.1 \
1082         man/hspace.1 \
1083         man/hroller.1 \
1084         man/htools.1 \
1085         man/mon-collector.7
1086
1087 # Remove extensions from all filenames in man_MANS
1088 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1089
1090 manrst = $(patsubst %,%.rst,$(mannoext))
1091 manhtml = $(patsubst %.rst,%.html,$(manrst))
1092 mangen = $(patsubst %.rst,%.gen,$(manrst))
1093 maninput = \
1094         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1095         $(patsubst %.html,%.html.in,$(manhtml)) \
1096         $(mangen)
1097
1098 TEST_FILES = \
1099         test/autotools/autotools-check-news.test \
1100         test/data/htools/clean-nonzero-score.data \
1101         test/data/htools/common-suffix.data \
1102         test/data/htools/empty-cluster.data \
1103         test/data/htools/hail-alloc-drbd.json \
1104         test/data/htools/hail-alloc-invalid-network.json \
1105         test/data/htools/hail-alloc-invalid-twodisks.json \
1106         test/data/htools/hail-alloc-restricted-network.json \
1107         test/data/htools/hail-alloc-spindles.json \
1108         test/data/htools/hail-alloc-twodisks.json \
1109         test/data/htools/hail-change-group.json \
1110         test/data/htools/hail-invalid-reloc.json \
1111         test/data/htools/hail-node-evac.json \
1112         test/data/htools/hail-reloc-drbd.json \
1113         test/data/htools/hbal-excl-tags.data \
1114         test/data/htools/hbal-split-insts.data \
1115         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1116         test/data/htools/hspace-tiered-dualspec.data \
1117         test/data/htools/hspace-tiered-exclusive.data \
1118         test/data/htools/hspace-tiered-ipolicy.data \
1119         test/data/htools/hspace-tiered-mixed.data \
1120         test/data/htools/hspace-tiered-resourcetypes.data \
1121         test/data/htools/hspace-tiered-vcpu.data \
1122         test/data/htools/hspace-tiered.data \
1123         test/data/htools/invalid-node.data \
1124         test/data/htools/missing-resources.data \
1125         test/data/htools/multiple-master.data \
1126         test/data/htools/multiple-tags.data \
1127         test/data/htools/n1-failure.data \
1128         test/data/htools/rapi/groups.json \
1129         test/data/htools/rapi/info.json \
1130         test/data/htools/rapi/instances.json \
1131         test/data/htools/rapi/nodes.json \
1132         test/data/htools/hroller-full.data \
1133         test/data/htools/hroller-nodegroups.data \
1134         test/data/htools/hroller-nonredundant.data \
1135         test/data/htools/hroller-online.data \
1136         test/data/htools/unique-reboot-order.data \
1137         test/hs/shelltests/htools-balancing.test \
1138         test/hs/shelltests/htools-basic.test \
1139         test/hs/shelltests/htools-dynutil.test \
1140         test/hs/shelltests/htools-excl.test \
1141         test/hs/shelltests/htools-hail.test \
1142         test/hs/shelltests/htools-hroller.test \
1143         test/hs/shelltests/htools-hspace.test \
1144         test/hs/shelltests/htools-invalid.test \
1145         test/hs/shelltests/htools-multi-group.test \
1146         test/hs/shelltests/htools-no-backend.test \
1147         test/hs/shelltests/htools-rapi.test \
1148         test/hs/shelltests/htools-single-group.test \
1149         test/hs/shelltests/htools-text-backend.test \
1150         test/hs/shelltests/htools-mon-collector.test \
1151         test/data/bdev-drbd-8.0.txt \
1152         test/data/bdev-drbd-8.3.txt \
1153         test/data/bdev-drbd-8.4.txt \
1154         test/data/bdev-drbd-8.4-no-disk-params.txt \
1155         test/data/bdev-drbd-disk.txt \
1156         test/data/bdev-drbd-net-ip4.txt \
1157         test/data/bdev-drbd-net-ip6.txt \
1158         test/data/bdev-rbd/json_output_empty.txt \
1159         test/data/bdev-rbd/json_output_extra_matches.txt \
1160         test/data/bdev-rbd/json_output_no_matches.txt \
1161         test/data/bdev-rbd/json_output_ok.txt \
1162         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1163         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1164         test/data/bdev-rbd/plain_output_new_ok.txt \
1165         test/data/bdev-rbd/plain_output_old_empty.txt \
1166         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1167         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1168         test/data/bdev-rbd/plain_output_old_ok.txt \
1169         test/data/bdev-rbd/output_invalid.txt \
1170         test/data/cert1.pem \
1171         test/data/cert2.pem \
1172         test/data/cluster_config_2.7.json \
1173         test/data/cluster_config_2.8.json \
1174         test/data/cluster_config_2.9.json \
1175         test/data/instance-minor-pairing.txt \
1176         test/data/instance-prim-sec.txt \
1177         test/data/ip-addr-show-dummy0.txt \
1178         test/data/ip-addr-show-lo-ipv4.txt \
1179         test/data/ip-addr-show-lo-ipv6.txt \
1180         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1181         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1182         test/data/ip-addr-show-lo-oneline.txt \
1183         test/data/ip-addr-show-lo.txt \
1184         test/data/kvm_0.12.5_help.txt \
1185         test/data/kvm_0.15.90_help.txt \
1186         test/data/kvm_0.9.1_help.txt \
1187         test/data/kvm_0.9.1_help_boot_test.txt \
1188         test/data/kvm_1.0_help.txt \
1189         test/data/kvm_1.1.2_help.txt \
1190         test/data/lvs_lv.txt \
1191         test/data/NEWS_OK.txt \
1192         test/data/NEWS_previous_unreleased.txt \
1193         test/data/ovfdata/compr_disk.vmdk.gz \
1194         test/data/ovfdata/config.ini \
1195         test/data/ovfdata/corrupted_resources.ovf \
1196         test/data/ovfdata/empty.ini \
1197         test/data/ovfdata/empty.ovf \
1198         test/data/ovfdata/ganeti.mf \
1199         test/data/ovfdata/ganeti.ovf \
1200         test/data/ovfdata/gzip_disk.ovf \
1201         test/data/ovfdata/new_disk.vmdk \
1202         test/data/ovfdata/no_disk.ini \
1203         test/data/ovfdata/no_disk_in_ref.ovf \
1204         test/data/ovfdata/no_os.ini \
1205         test/data/ovfdata/no_ovf.ova \
1206         test/data/ovfdata/other/rawdisk.raw \
1207         test/data/ovfdata/ova.ova \
1208         test/data/ovfdata/rawdisk.raw \
1209         test/data/ovfdata/second_disk.vmdk \
1210         test/data/ovfdata/unsafe_path.ini \
1211         test/data/ovfdata/virtualbox.ovf \
1212         test/data/ovfdata/wrong_config.ini \
1213         test/data/ovfdata/wrong_extension.ovd \
1214         test/data/ovfdata/wrong_manifest.mf \
1215         test/data/ovfdata/wrong_manifest.ovf \
1216         test/data/ovfdata/wrong_ova.ova \
1217         test/data/ovfdata/wrong_xml.ovf \
1218         test/data/proc_diskstats.txt \
1219         test/data/proc_drbd8.txt \
1220         test/data/proc_drbd80-emptyline.txt \
1221         test/data/proc_drbd80-emptyversion.txt \
1222         test/data/proc_drbd83.txt \
1223         test/data/proc_drbd83_sync.txt \
1224         test/data/proc_drbd83_sync_want.txt \
1225         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1226         test/data/proc_drbd84.txt \
1227         test/data/proc_drbd84_emptyfirst.txt \
1228         test/data/proc_drbd84_sync.txt \
1229         test/data/proc_meminfo.txt \
1230         test/data/proc_cpuinfo.txt \
1231         test/data/qa-minimal-nodes-instances-only.json \
1232         test/data/sys_drbd_usermode_helper.txt \
1233         test/data/vgreduce-removemissing-2.02.02.txt \
1234         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1235         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1236         test/data/vgs-missing-pvs-2.02.02.txt \
1237         test/data/vgs-missing-pvs-2.02.66.txt \
1238         test/data/xen-xm-info-4.0.1.txt \
1239         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1240         test/data/xen-xm-list-4.0.1-four-instances.txt \
1241         test/data/xen-xm-list-long-4.0.1.txt \
1242         test/data/xen-xm-uptime-4.0.1.txt \
1243         test/py/ganeti-cli.test \
1244         test/py/gnt-cli.test \
1245         test/py/import-export_unittest-helper
1246
1247
1248 python_tests = \
1249         doc/examples/rapi_testutils.py \
1250         test/py/cfgupgrade_unittest.py \
1251         test/py/docs_unittest.py \
1252         test/py/ganeti.asyncnotifier_unittest.py \
1253         test/py/ganeti.backend_unittest-runasroot.py \
1254         test/py/ganeti.backend_unittest.py \
1255         test/py/ganeti.bootstrap_unittest.py \
1256         test/py/ganeti.cli_unittest.py \
1257         test/py/ganeti.client.gnt_cluster_unittest.py \
1258         test/py/ganeti.client.gnt_instance_unittest.py \
1259         test/py/ganeti.client.gnt_job_unittest.py \
1260         test/py/ganeti.cmdlib_unittest.py \
1261         test/py/ganeti.cmdlib.cluster_unittest.py \
1262         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1263         test/py/ganeti.compat_unittest.py \
1264         test/py/ganeti.confd.client_unittest.py \
1265         test/py/ganeti.config_unittest.py \
1266         test/py/ganeti.constants_unittest.py \
1267         test/py/ganeti.daemon_unittest.py \
1268         test/py/ganeti.errors_unittest.py \
1269         test/py/ganeti.hooks_unittest.py \
1270         test/py/ganeti.ht_unittest.py \
1271         test/py/ganeti.http_unittest.py \
1272         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1273         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1274         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1275         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1276         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1277         test/py/ganeti.hypervisor_unittest.py \
1278         test/py/ganeti.impexpd_unittest.py \
1279         test/py/ganeti.jqueue_unittest.py \
1280         test/py/ganeti.jstore_unittest.py \
1281         test/py/ganeti.locking_unittest.py \
1282         test/py/ganeti.luxi_unittest.py \
1283         test/py/ganeti.masterd.iallocator_unittest.py \
1284         test/py/ganeti.masterd.instance_unittest.py \
1285         test/py/ganeti.mcpu_unittest.py \
1286         test/py/ganeti.netutils_unittest.py \
1287         test/py/ganeti.objects_unittest.py \
1288         test/py/ganeti.opcodes_unittest.py \
1289         test/py/ganeti.outils_unittest.py \
1290         test/py/ganeti.ovf_unittest.py \
1291         test/py/ganeti.qlang_unittest.py \
1292         test/py/ganeti.query_unittest.py \
1293         test/py/ganeti.rapi.baserlib_unittest.py \
1294         test/py/ganeti.rapi.client_unittest.py \
1295         test/py/ganeti.rapi.resources_unittest.py \
1296         test/py/ganeti.rapi.rlib2_unittest.py \
1297         test/py/ganeti.rapi.testutils_unittest.py \
1298         test/py/ganeti.rpc_unittest.py \
1299         test/py/ganeti.runtime_unittest.py \
1300         test/py/ganeti.serializer_unittest.py \
1301         test/py/ganeti.server.rapi_unittest.py \
1302         test/py/ganeti.ssconf_unittest.py \
1303         test/py/ganeti.ssh_unittest.py \
1304         test/py/ganeti.storage.bdev_unittest.py \
1305         test/py/ganeti.storage.container_unittest.py \
1306         test/py/ganeti.storage.drbd_unittest.py \
1307         test/py/ganeti.storage.filestorage_unittest.py \
1308         test/py/ganeti.tools.burnin_unittest.py \
1309         test/py/ganeti.tools.ensure_dirs_unittest.py \
1310         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1311         test/py/ganeti.tools.prepare_node_join_unittest.py \
1312         test/py/ganeti.uidpool_unittest.py \
1313         test/py/ganeti.utils.algo_unittest.py \
1314         test/py/ganeti.utils.filelock_unittest.py \
1315         test/py/ganeti.utils.hash_unittest.py \
1316         test/py/ganeti.utils.io_unittest-runasroot.py \
1317         test/py/ganeti.utils.io_unittest.py \
1318         test/py/ganeti.utils.log_unittest.py \
1319         test/py/ganeti.utils.lvm_unittest.py \
1320         test/py/ganeti.utils.mlock_unittest.py \
1321         test/py/ganeti.utils.nodesetup_unittest.py \
1322         test/py/ganeti.utils.process_unittest.py \
1323         test/py/ganeti.utils.retry_unittest.py \
1324         test/py/ganeti.utils.storage_unittest.py \
1325         test/py/ganeti.utils.text_unittest.py \
1326         test/py/ganeti.utils.wrapper_unittest.py \
1327         test/py/ganeti.utils.x509_unittest.py \
1328         test/py/ganeti.utils_unittest.py \
1329         test/py/ganeti.vcluster_unittest.py \
1330         test/py/ganeti.workerpool_unittest.py \
1331         test/py/pycurl_reset_unittest.py \
1332         test/py/qa.qa_config_unittest.py \
1333         test/py/tempfile_fork_unittest.py
1334
1335 haskell_tests = test/hs/htest
1336
1337 dist_TESTS = \
1338         test/py/check-cert-expired_unittest.bash \
1339         test/py/daemon-util_unittest.bash \
1340         test/py/ganeti-cleaner_unittest.bash \
1341         test/py/import-export_unittest.bash \
1342         test/py/cli-test.bash \
1343         test/py/bash_completion.bash
1344
1345 if PY_UNIT
1346 dist_TESTS += $(python_tests)
1347 endif
1348
1349 nodist_TESTS =
1350 check_SCRIPTS =
1351
1352 if WANT_HSTESTS
1353 nodist_TESTS += $(haskell_tests)
1354 dist_TESTS += test/hs/offline-test.sh
1355 check_SCRIPTS += \
1356         test/hs/hpc-htools \
1357         test/hs/hpc-mon-collector \
1358         $(HS_BUILT_TEST_HELPERS)
1359 endif
1360
1361 TESTS = $(dist_TESTS) $(nodist_TESTS)
1362
1363 # Environment for all tests
1364 PLAIN_TESTS_ENVIRONMENT = \
1365         PYTHONPATH=. \
1366         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1367         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1368         $(RUN_IN_TEMPDIR)
1369
1370 # Environment for tests run by automake
1371 TESTS_ENVIRONMENT = \
1372         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1373
1374 all_python_code = \
1375         $(dist_sbin_SCRIPTS) \
1376         $(python_scripts) \
1377         $(pkglib_python_scripts) \
1378         $(nodist_pkglib_python_scripts) \
1379         $(nodist_tools_python_scripts) \
1380         $(pkgpython_PYTHON) \
1381         $(client_PYTHON) \
1382         $(cmdlib_PYTHON) \
1383         $(hypervisor_PYTHON) \
1384         $(storage_PYTHON) \
1385         $(rapi_PYTHON) \
1386         $(server_PYTHON) \
1387         $(pytools_PYTHON) \
1388         $(http_PYTHON) \
1389         $(confd_PYTHON) \
1390         $(masterd_PYTHON) \
1391         $(impexpd_PYTHON) \
1392         $(utils_PYTHON) \
1393         $(watcher_PYTHON) \
1394         $(noinst_PYTHON) \
1395         $(qa_scripts)
1396
1397 if PY_UNIT
1398 all_python_code += $(python_tests)
1399 endif
1400
1401 srclink_files = \
1402         man/footer.rst \
1403         test/py/check-cert-expired_unittest.bash \
1404         test/py/daemon-util_unittest.bash \
1405         test/py/ganeti-cleaner_unittest.bash \
1406         test/py/import-export_unittest.bash \
1407         test/py/cli-test.bash \
1408         test/py/bash_completion.bash \
1409         test/hs/offline-test.sh \
1410         test/hs/cli-tests-defs.sh \
1411         $(all_python_code) \
1412         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1413         $(docinput)
1414
1415 check_python_code = \
1416         $(BUILD_BASH_COMPLETION) \
1417         $(CHECK_IMPORTS) \
1418         $(CHECK_HEADER) \
1419         $(DOCPP) \
1420         $(all_python_code)
1421
1422 lint_python_code = \
1423         ganeti \
1424         ganeti/http/server.py \
1425         $(dist_sbin_SCRIPTS) \
1426         $(python_scripts) \
1427         $(pkglib_python_scripts) \
1428         $(BUILD_BASH_COMPLETION) \
1429         $(CHECK_IMPORTS) \
1430         $(CHECK_HEADER) \
1431         $(DOCPP) \
1432         $(PYTHON_BOOTSTRAP)
1433
1434 standalone_python_modules = \
1435         lib/rapi/client.py \
1436         tools/ganeti-listrunner
1437
1438 pep8_python_code = \
1439         ganeti \
1440         ganeti/http/server.py \
1441         $(dist_sbin_SCRIPTS) \
1442         $(python_scripts) \
1443         $(pkglib_python_scripts) \
1444         $(BUILD_BASH_COMPLETION) \
1445         $(CHECK_HEADER) \
1446         $(DOCPP) \
1447         $(PYTHON_BOOTSTRAP) \
1448         qa
1449
1450 test/py/daemon-util_unittest.bash: daemons/daemon-util
1451
1452 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1453
1454 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1455
1456 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1457         sed -f $(REPLACE_VARS_SED) < $< > $@
1458         chmod +x $@
1459
1460 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1461         sed -f $(REPLACE_VARS_SED) < $< > $@
1462         chmod +x $@
1463
1464 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1465         sed -f $(REPLACE_VARS_SED) < $< > $@
1466         chmod +x $@
1467
1468 tools/users-setup: Makefile $(userspecs)
1469         set -e; \
1470         { echo '#!/bin/sh'; \
1471           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1472           echo 'then echo "This will do the following changes"'; \
1473           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1474                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1475           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1476                                   else {print "echo + Will add user",$$1}; count++}\
1477                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1478           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1479           echo 'echo'; \
1480           echo 'echo "OK? (y/n)"'; \
1481           echo 'read confirm'; \
1482           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1483           echo 'fi'; \
1484           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1485           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1486           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1487         } > $@
1488         chmod +x $@
1489
1490 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1491         sed -f $(REPLACE_VARS_SED) < $< > $@
1492         chmod +x $@
1493
1494 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1495         sed -f $(REPLACE_VARS_SED) < $< > $@
1496         chmod +x $@
1497
1498 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1499         sed -f $(REPLACE_VARS_SED) < $< > $@
1500
1501 doc/examples/bash_completion: BC_ARGS = --compact
1502 doc/examples/bash_completion-debug: BC_ARGS =
1503
1504 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1505         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1506         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1507         daemons/ganeti-cleaner \
1508         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1509         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1510           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1511
1512 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1513         lib/build/shell_example_lexer.py \
1514         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1515         @echo "Checking $< for hardcoded paths..."
1516         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1517           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1518           exit 1; \
1519         fi
1520         set -e ; \
1521         trap 'echo auto-removing $@; rm $@' EXIT; \
1522         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1523         $(CHECK_MAN_REFERENCES) $@; \
1524         trap - EXIT
1525
1526 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1527         @test -n "$(PANDOC)" || \
1528           { echo 'pandoc' not found during configure; exit 1; }
1529         set -o pipefail -e; \
1530         trap 'echo auto-removing $@; rm $@' EXIT; \
1531         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1532           sed -e 's/\\@/@/g' > $@; \
1533         if test -n "$(MAN_HAS_WARNINGS)"; then LC_ALL=en_US.UTF-8 $(CHECK_MAN_WARNINGS) $@; fi; \
1534         $(CHECK_MAN_DASHES) $@; \
1535         trap - EXIT
1536
1537 man/%.html.in: man/%.gen man/footer.rst
1538         @test -n "$(PANDOC)" || \
1539           { echo 'pandoc' not found during configure; exit 1; }
1540         set -o pipefail ; \
1541         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1542           sed -e 's/\\@/@/g' > $@
1543
1544 man/%: man/%.in  $(REPLACE_VARS_SED)
1545         sed -f $(REPLACE_VARS_SED) < $< > $@
1546
1547 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1548         sed -f $(REPLACE_VARS_SED) < $< > $@
1549
1550 vcs-version:
1551         if test -d .git; then \
1552           git describe > $@; \
1553         elif test ! -f $@ ; then \
1554           echo "Cannot auto-generate $@ file"; exit 1; \
1555         fi
1556
1557 .PHONY: clean-vcs-version
1558 clean-vcs-version:
1559         rm -f vcs-version
1560
1561 .PHONY: regen-vcs-version
1562 regen-vcs-version:
1563         @set -e; \
1564         cd $(srcdir); \
1565         if test -d .git; then \
1566           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1567           git describe > $$T; \
1568           if ! cmp --quiet $$T vcs-version; then \
1569             mv $$T vcs-version; \
1570           fi; \
1571         fi
1572
1573 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1574         vcs-version $(built_base_sources)
1575         set -e; \
1576         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1577         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1578
1579 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1580         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1581         lib/jstore.py $(RUN_IN_TEMPDIR) \
1582         $(CONVERT_CONSTANTS) $(built_base_sources) \
1583         | lib/_vcsversion.py
1584         set -e; \
1585         { cat $< ; \
1586           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1587         } > $@
1588
1589 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1590         hsc2hs -o $@ $<
1591
1592 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1593         $(built_base_sources)
1594         set -e; \
1595         { cat $< ; \
1596           echo ; \
1597           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1598             echo "import $$name ()" ; \
1599           done ; \
1600         } > $@
1601
1602 lib/_autoconf.py: Makefile | stamp-directories
1603         set -e; \
1604         { echo '# This file is automatically generated, do not edit!'; \
1605           echo '#'; \
1606           echo ''; \
1607           echo '"""Build-time configuration for Ganeti.'; \
1608           echo '';\
1609           echo 'This file is autogenerated by the build process.'; \
1610           echo 'For any changes you need to re-run ./configure (and'; \
1611           echo 'not edit by hand).'; \
1612           echo ''; \
1613           echo '"""'; \
1614           echo ''; \
1615           echo '# pylint: disable=C0301,C0324'; \
1616           echo '# because this is autogenerated, we do not want'; \
1617           echo '# style warnings' ; \
1618           echo ''; \
1619           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1620           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1621           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1622           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1623           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1624           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1625           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1626           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1627           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1628           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1629           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1630           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1631           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1632           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1633           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1634           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1635           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1636           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1637           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1638           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1639           echo "KVM_PATH = '$(KVM_PATH)'"; \
1640           echo "IP_PATH = '$(IP_PATH)'"; \
1641           echo "SOCAT_PATH = '$(SOCAT)'"; \
1642           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1643           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1644           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1645           echo "TOOLSDIR = '$(toolsdir)'"; \
1646           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1647           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1648           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1649           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1650           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1651           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1652           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1653           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1654           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1655           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1656           echo "RAPI_USER = '$(RAPI_USER)'"; \
1657           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1658           echo "CONFD_USER = '$(CONFD_USER)'"; \
1659           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1660           echo "LUXID_USER = '$(LUXID_USER)'"; \
1661           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1662           echo "NODED_USER = '$(NODED_USER)'"; \
1663           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1664           echo "MOND_USER = '$(MOND_USER)'"; \
1665           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1666           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1667           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1668           echo "HTOOLS = True"; \
1669           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1670           echo "XEN_CMD = '$(XEN_CMD)'"; \
1671           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1672           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1673           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1674 ## Write dictionary with man page name as the key and the section number as the
1675 ## value
1676           echo "MAN_PAGES = {"; \
1677           for i in $(notdir $(man_MANS)); do \
1678             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1679           done; \
1680           echo "}"; \
1681         } > $@
1682
1683 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1684         set -e; \
1685         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1686         { echo '# This file is automatically generated, do not edit!'; \
1687           echo '#'; \
1688           echo ''; \
1689           echo '"""Build-time VCS version number for Ganeti.'; \
1690           echo '';\
1691           echo 'This file is autogenerated by the build process.'; \
1692           echo 'For any changes you need to re-run ./configure (and'; \
1693           echo 'not edit by hand).'; \
1694           echo ''; \
1695           echo '"""'; \
1696           echo ''; \
1697           echo '# pylint: disable=C0301,C0324'; \
1698           echo '# because this is autogenerated, we do not want'; \
1699           echo '# style warnings' ; \
1700           echo ''; \
1701           echo "VCS_VERSION = '$$VCSVER'"; \
1702         } > $@
1703
1704 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1705         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1706
1707 $(SHELL_ENV_INIT): Makefile stamp-directories
1708         set -e; \
1709         { echo '# Allow overriding for tests'; \
1710           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1711           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1712           echo; \
1713           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1714           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1715           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1716           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1717           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1718         } > $@
1719
1720 ## Writes sed script to replace placeholders with build-time values. The
1721 ## additional quotes after the first @ sign are necessary to stop configure
1722 ## from replacing those values as well.
1723 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1724         set -e; \
1725         { echo 's#@''PREFIX@#$(prefix)#g'; \
1726           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1727           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1728           echo 's#@''BINDIR@#$(bindir)#g'; \
1729           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1730           echo 's#@''LIBDIR@#$(libdir)#g'; \
1731           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1732           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1733           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1734           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1735           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1736           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1737           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1738           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1739           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1740           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1741           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1742           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1743           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1744           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1745           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1746           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1747           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1748           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1749           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1750           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1751           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1752           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1753           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1754           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1755           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1756           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1757           echo; \
1758           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1759           echo '  r $(SHELL_ENV_INIT)'; \
1760           echo '  d'; \
1761           echo '}'; \
1762         } > $@
1763
1764 # Using deferred evaluation
1765 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1766 daemons/ganeti-watcher: MODULE = ganeti.watcher
1767 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1768 tools/burnin: MODULE = ganeti.tools.burnin
1769 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1770 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1771 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1772 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1773 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1774
1775 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1776         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1777         set -e; \
1778         { echo '#!/usr/bin/python'; \
1779           echo '# This file is automatically generated, do not edit!'; \
1780           echo "# Edit $(MODULE) instead."; \
1781           echo; \
1782           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1783           echo; \
1784           echo '# pylint: disable=C0103'; \
1785           echo '# C0103: Invalid name'; \
1786           echo; \
1787           echo 'import sys'; \
1788           echo 'import $(MODULE) as main'; \
1789           echo; \
1790           echo '# Temporarily alias commands until bash completion'; \
1791           echo '# generator is changed'; \
1792           echo 'if hasattr(main, "commands"):'; \
1793           echo '  commands = main.commands # pylint: disable=E1101'; \
1794           echo 'if hasattr(main, "aliases"):'; \
1795           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1796           echo; \
1797           echo 'if __name__ == "__main__":'; \
1798           echo '  sys.exit(main.Main())'; \
1799         } > $@
1800         chmod u+x $@
1801
1802 $(HS_BUILT_TEST_HELPERS): Makefile
1803         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1804         set -e; \
1805         { echo '#!/bin/sh'; \
1806           echo '# This file is automatically generated, do not edit!'; \
1807           echo "# Edit Makefile.am instead."; \
1808           echo; \
1809           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1810         } > $@
1811         chmod u+x $@
1812
1813 stamp-directories: Makefile
1814         $(MAKE) $(AM_MAKEFLAGS) ganeti
1815         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1816         touch $@
1817
1818 # We need to create symlinks because "make distcheck" will not install Python
1819 # files when building.
1820 stamp-srclinks: Makefile | stamp-directories
1821         set -e; \
1822         for i in $(srclink_files); do \
1823           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1824             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1825           fi; \
1826         done
1827         touch $@
1828
1829 .PHONY: ganeti
1830 ganeti:
1831         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1832
1833 .PHONY: check-dirs
1834 check-dirs: $(GENERATED_FILES)
1835         @set -e; \
1836         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1837           error=; \
1838           while read dir; do \
1839             case "$$dir" in \
1840               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1841               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1842             esac; \
1843           done; \
1844           for dir in $(DIRS); do \
1845             if ! test -d "$$dir"; then \
1846               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1847               error=1; \
1848             fi \
1849           done; \
1850           test -z "$$error"; \
1851         }
1852
1853 .PHONY: check-local
1854 check-local: check-dirs $(GENERATED_FILES)
1855         $(CHECK_PYTHON_CODE) $(check_python_code)
1856         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1857         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1858         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1859         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1860         error= ; \
1861         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1862           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1863           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1864             echo "Incorrect version in README, expected $$expver" >&2; \
1865             error=1; \
1866           fi; \
1867           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1868               doc/security.rst; do \
1869             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1870               "Documents Ganeti version $$expver"; then \
1871               echo "Incorrect version in $$file, expected $$expver" >&2; \
1872               error=1; \
1873             fi; \
1874           done; \
1875           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1876             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1877             error=1; \
1878           fi; \
1879           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1880             ".. Last updated for Ganeti $$expver"; then \
1881             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1882             error=1; \
1883           fi; \
1884         fi; \
1885         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1886           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1887             echo "Longest line in $$file is longer than 80 characters" >&2; \
1888             error=1; \
1889           fi; \
1890         done; \
1891         test -z "$$error"
1892
1893 .PHONY: hs-test-%
1894 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1895         @rm -f htest.tix
1896         test/hs/htest -t $*
1897
1898 .PHONY: hs-tests
1899 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1900         @rm -f htest.tix
1901         ./test/hs/htest
1902
1903 .PHONY: hs-shell-%
1904 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1905             $(HS_BUILT_TEST_HELPERS)
1906         @rm -f hpc-htools.tix hpc-mon-collector.tix
1907         HBINARY="./test/hs/hpc-htools" \
1908         SHELLTESTARGS=$(SHELLTESTARGS) \
1909         ./test/hs/offline-test.sh $*
1910
1911 .PHONY: hs-shell
1912 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1913         @rm -f hpc-htools.tix hpc-mon-collector.tix
1914         HBINARY="./test/hs/hpc-htools" \
1915         SHELLTESTARGS=$(SHELLTESTARGS) \
1916         ./test/hs/offline-test.sh
1917
1918 .PHONY: hs-check
1919 hs-check: hs-tests hs-shell
1920
1921 # E111: indentation is not a multiple of four
1922 # E121: continuation line indentation is not a multiple of four
1923 #       (since our indent level is not 4)
1924 # E125: continuation line does not distinguish itself from next logical line
1925 #       (since our indent level is not 4)
1926 # E123: closing bracket does not match indentation of opening bracket's line
1927 # E127: continuation line over-indented for visual indent
1928 #       (since our indent level is not 4)
1929 # note: do NOT add E128 here; it's a valid style error in most cases!
1930 # I've seen real errors, but also some cases were we indent wrongly
1931 # due to line length; try to rework the cases where it is triggered,
1932 # instead of silencing it
1933 # E261: at least two spaces before inline comment
1934 # E501: line too long (80 characters)
1935 PEP8_IGNORE = E111,E121,E123,E125,E127,E261,E501
1936
1937 # For excluding pep8 expects filenames only, not whole paths
1938 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1939
1940 LINT_TARGETS = pylint pylint-qa
1941 if HAS_PEP8
1942 LINT_TARGETS += pep8
1943 endif
1944 if HAS_HLINT
1945 LINT_TARGETS += hlint
1946 endif
1947
1948 .PHONY: lint
1949 lint: $(LINT_TARGETS)
1950
1951 .PHONY: pylint
1952 pylint: $(GENERATED_FILES)
1953         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1954         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1955
1956 .PHONY: pylint-qa
1957 pylint-qa: $(GENERATED_FILES)
1958         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1959         cd $(top_srcdir)/qa && \
1960           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1961           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1962
1963 .PHONY: pep8
1964 pep8: $(GENERATED_FILES)
1965         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1966         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1967           --repeat $(pep8_python_code)
1968
1969 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1970 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1971 .PHONY: hlint
1972 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1973         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1974         @rm -f doc/hs-lint.html
1975         if tty -s; then C="-c"; else C=""; fi; \
1976         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1977           --ignore "Use first" \
1978           --ignore "Use &&&" \
1979           --ignore "Use void" \
1980           --ignore "Reduce duplication" \
1981           --hint src/lint-hints \
1982           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1983         @if [ ! -f doc/hs-lint.html ]; then \
1984           echo "All good" > doc/hs-lint.html; \
1985         fi
1986
1987 # a dist hook rule for updating the vcs-version file; this is
1988 # hardcoded due to where it needs to build the file...
1989 dist-hook:
1990         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1991         rm -f $(top_distdir)/vcs-version
1992         cp -p $(srcdir)/vcs-version $(top_distdir)
1993
1994 # a distcheck hook rule for catching revision control directories
1995 distcheck-hook:
1996         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1997           echo "Found revision control files in final archive." 1>&2; \
1998           exit 1; \
1999         fi
2000         if find $(top_distdir) -name '*.py[co]' | grep .; then \
2001           echo "Found Python byte code in final archive." 1>&2; \
2002           exit 1; \
2003         fi
2004         if find $(top_distdir) -name '*~' | grep .; then \
2005           echo "Found backup files in final archive." 1>&2; \
2006           exit 1; \
2007         fi
2008 # Empty files or directories should not be distributed. They can cause
2009 # unnecessary warnings for packagers. Directories used by automake during
2010 # distcheck must be excluded.
2011         if find $(top_distdir) -empty -and -not \( \
2012             -path $(top_distdir)/_build -or \
2013             -path $(top_distdir)/_inst \) | grep .; then \
2014           echo "Found empty files or directories in final archive." 1>&2; \
2015           exit 1; \
2016         fi
2017         if test -e $(top_distdir)/doc/man-html; then \
2018           echo "Found documentation including man pages in final archive" >&2; \
2019           exit 1; \
2020         fi
2021
2022 # Backwards compatible distcheck-release target
2023 distcheck-release: distcheck
2024
2025 distrebuildcheck: dist
2026         set -e; \
2027         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
2028         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
2029         cd $$builddir; \
2030         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
2031         cd $(distdir); \
2032         ./configure; \
2033         $(MAKE) maintainer-clean; \
2034         cp $(abs_srcdir)/vcs-version .; \
2035         ./configure; \
2036         $(MAKE) $(AM_MAKEFLAGS)
2037
2038 dist-release: dist
2039         set -e; \
2040         for i in $(DIST_ARCHIVES); do \
2041           echo -n "Checking $$i ... "; \
2042           autotools/check-tar < $$i; \
2043           echo OK; \
2044         done
2045
2046 install-exec-local:
2047         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2048           "$(DESTDIR)${localstatedir}/log/ganeti" \
2049           "$(DESTDIR)${localstatedir}/run/ganeti"
2050
2051 .PHONY: apidoc
2052 if WANT_HSAPIDOC
2053 apidoc: py-apidoc hs-apidoc
2054 else
2055 apidoc: py-apidoc
2056 endif
2057
2058 .PHONY: py-apidoc
2059 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2060         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2061         $(RUN_IN_TEMPDIR) epydoc -v \
2062           --conf $(CURDIR)/epydoc.conf \
2063           --output $(CURDIR)/$(APIDOC_PY_DIR)
2064
2065 .PHONY: hs-apidoc
2066 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2067
2068 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2069         @test -n "$(HSCOLOUR)" || \
2070             { echo 'HsColour' not found during configure; exit 1; }
2071         @test -n "$(HADDOCK)" || \
2072             { echo 'haddock' not found during configure; exit 1; }
2073         rm -rf $(APIDOC_HS_DIR)/*
2074         for i in $(ALL_APIDOC_HS_DIRS); do \
2075           @mkdir_p@ $$i; \
2076           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2077         done
2078         set -e ; \
2079         export LC_ALL=en_US.UTF-8; \
2080         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2081         if [ "$(HS_PARALLEL3)" ]; \
2082         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2083         fi; \
2084         if [ "$(HS_REGEX_PCRE)" ]; \
2085         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2086         fi; \
2087         for file in $(HS_LIBTESTBUILT_SRCS); do \
2088           f_nosrc=$${file##src/}; \
2089           f_notst=$${f_nosrc##test/hs/}; \
2090           f_html=$${f_notst%%.hs}.html; \
2091           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2092         done ; \
2093         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2094           -t ganeti -p src/haddock-prologue \
2095           --source-module="%{MODULE/.//}.html" \
2096           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2097           $$OPTGHC \
2098           $(HS_LIBTESTBUILT_SRCS)
2099
2100 .PHONY: TAGS
2101 TAGS: $(GENERATED_FILES)
2102         rm -f TAGS
2103         $(GHC) -e ":etags" -v0 \
2104           $(filter-out -O -Werror,$(HFLAGS)) \
2105           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2106           $(HS_LIBTEST_SRCS)
2107         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2108           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2109           -path './qa/*.py' | \
2110           etags -l python -a -
2111
2112 .PHONY: coverage
2113
2114 COVERAGE_TESTS=
2115 if WANT_HTOOLS
2116 COVERAGE_TESTS += hs-coverage
2117 endif
2118 if PY_UNIT
2119 COVERAGE_TESTS += py-coverage
2120 endif
2121
2122 coverage: $(COVERAGE_TESTS)
2123
2124 .PHONY: py-coverage
2125 py-coverage: $(GENERATED_FILES) $(python_tests)
2126         @test -n "$(PYCOVERAGE)" || \
2127             { echo 'python-coverage' not found during configure; exit 1; }
2128         set -e; \
2129         COVERAGE=$(PYCOVERAGE) \
2130         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2131         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2132         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2133         $(PLAIN_TESTS_ENVIRONMENT) \
2134         $(abs_top_srcdir)/autotools/gen-py-coverage \
2135         $(python_tests)
2136
2137 .PHONY: hs-coverage
2138 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2139         rm -f *.tix
2140         $(MAKE) $(AM_MAKEFLAGS) hs-check
2141         @mkdir_p@ $(COVERAGE_HS_DIR)
2142         hpc sum --union $(HPCEXCL) \
2143           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2144         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2145         hpc report coverage-hs.tix
2146         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2147
2148 # Special "kind-of-QA" target for htools, needs special setup (all
2149 # tools compiled with -fhpc)
2150 .PHONY: live-test
2151 live-test: all
2152         set -e ; \
2153         cd src; \
2154         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2155         rm -f *.tix *.mix; \
2156         ./live-test.sh; \
2157         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2158           --output=live-test.tix ; \
2159         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2160         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2161           --srcdir=.. $(HPCEXCL) ; \
2162         hpc report --srcdir=.. live-test $(HPCEXCL)
2163
2164 commit-check: autotools-check distcheck lint apidoc
2165
2166 autotools-check:
2167         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2168   $(abs_top_srcdir)/test/autotools/*-*.test \
2169   -- --hide-successes
2170
2171 .PHONY: gitignore-check
2172 gitignore-check:
2173         @if [ -n "`git status --short`" ]; then \
2174           echo "Git status is not clean!" 1>&2 ; \
2175           git status --short; \
2176           exit 1; \
2177         fi
2178
2179 # target to rebuild all man pages (both groff and html output)
2180 .PHONY: man
2181 man: $(man_MANS) $(manhtml)
2182
2183 # Target that builds all binaries (including those that are not
2184 # rebuilt except when running the tests)
2185 .PHONY: really-all
2186 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2187
2188 # we don't need the ancient implicit rules:
2189 %: %,v
2190 %: RCS/%,v
2191 %: RCS/%
2192 %: s.%
2193 %: SCCS/s.%
2194
2195 -include ./Makefile.local
2196
2197 # vim: set noet :